Index: /trunk/gli/src/org/greenstone/gatherer/util/StaticStrings.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/util/StaticStrings.java	(revision 14050)
+++ /trunk/gli/src/org/greenstone/gatherer/util/StaticStrings.java	(revision 14051)
@@ -46,8 +46,10 @@
     static final public String ASSOCIATIONS_ELEMENT = "Associations";
     static final public String ATTRIBUTE_ELEMENT = "Attribute";
+    static final public String BROWSE_STR = "browse";
     static final public String BUILDTYPE_ELEMENT = "BuildType";
     static final public String BUILDTYPE_STR = "buildtype";
     static final public String CASEFOLD_OPTION_STR = "casefold";
     static final public String CCS_STR = "ccs";
+    static final public String CLASSIFIER_STR = "classifier";
     static final public String CLASSIFY_ELEMENT = "Classify";
     static final public String CLASSIFY_STR = "classify";
@@ -56,4 +58,5 @@
     static final public String COLNAME_PATTERN = "<col_name>";
     static final public String COLLECT_CFG = "collect.cfg";
+    static final public String COLLECTION_CFG_XML = "collectionConfig.xml";
     static final public String COLLECTDIR_ARGUMENT = "-collectdir";
     static final public String COLLECTION_ELEMENT = "Collection";
@@ -83,6 +86,11 @@
     static final public String DEBUG_ARGUMENT = "-debug";
     static final public String DESCRIPTION_ELEMENT = "Description";
+    static final public String DESCRIPTION_STR = "description";
     static final public String DIRECTORY_MAPPINGS_ELEMENT = "DirectoryMappings";
+    static final public String DISPLAYITEMLIST_STR = "displayItemList";
+    static final public String DISPLAY_STR = "display";
+    static final public String DISPLAYITEM_STR = "displayItem";
     static final public String DOCUMENT_STR = "document";
+    static final public String DOT_CHARACTER = ".";
     static final public String EMPTY_STR = "";
     static final public String ENGLISH_LANGUAGE_STR = "en";
@@ -98,7 +106,10 @@
     static final public String FILE_ATTRIBUTE = "file";
     static final public String FILENAME_STR = "Filename";
+    static final public String FILTER_ATTRIBUTE = "filter";
     static final public String FLAG_STR = "flag";
     static final public String FORMAT_ELEMENT = "Format";
     static final public String FORMAT_STR = "format";
+    static final public String FORMAT_START_TAG = "<format>";
+    static final public String FORMAT_END_TAG = "</format>";
     static final public String FURTHER_DIALOG_INDICATOR = "...";
     static final public String GLI_ATTRIBUTE = "gli";
@@ -114,8 +125,12 @@
     static final public String HELP_ARGUMENT = "-help";
     static final public String HTM_FILE_EXTENSION = ".htm";
+    static final public String ICON_STR = "icon";
+    static final public String ID_STR = "id";
     static final public String IMAGES_PATH_RELATIVE_TO_GSDL_PREFIX = "_httpprefix_/collect/<col_name>/images/";
     static final public String INCLUDE_STR = "include";
     static final public String INDEX_ELEMENT = "Index";
+    static final public String INDEX_LOW_STR = "index";
     static final public String INDEX_DEFAULT_ELEMENT = "DefaultIndex";
+    static final public String INDEX_DEFAULT_ELEMENT_LOWERCASE = "defaultIndex";
     static final public String INDEX_DEFAULT_STR = "defaultindex";
     static final public String INDEX_STR = "indexes";
@@ -123,6 +138,9 @@
     static final public String INDEXOPTION_ELEMENT = "Option";
     static final public String INDEXOPTIONS_ELEMENT = "IndexOption";
+    static final public String INDEXOPTION_STR = "indexOption";
+    static final public String INDEXOPTIONS_STR = "indexoptions";
     static final public String INDEXOPTION_DEFAULT_ELEMENT = "DefaultIndexOption";
     static final public String INT_STR = "int";
+    static final public String IMPORT_STR = "import";
     static final public String[] KEEP_PLUG = { "GAPlug", "METSPlug" };
     static final public String LANGUAGE_ARGUMENT = "l=";
@@ -130,7 +148,12 @@
     static final public String LANGUAGE_ELEMENT = "Language";
     static final public String LANGUAGE_DEFAULT_ELEMENT = "DefaultLanguage";
+    static final public String LANGUAGE_DEFAULT_INDEX_ELEMENT = "defaultIndexLanguage";
     static final public String LANGUAGE_DEFAULT_STR = "defaultlanguage";
+    static final public String LANGUAGE_INDEX_ELEMENT = "indexLanguage";
     static final public String LANGUAGE_METADATA_ELEMENT = "LanguageMetadata";
+    static final public String LANGUAGE_METADATA_ELEMENT_STR = "languageMetadata";
     static final public String LANGUAGE_METADATA_STR = "languagemetadata";
+    static final public String LANG_STR = "lang";
+    static final public String LANG_ATTRIBUTE = "lang";
     static final public String LANGUAGE_STR = "language";
     static final public String LANGUAGES_ELEMENT = "Languages";
@@ -139,4 +162,6 @@
     static final public String LESS_THAN_CHARACTER = "<";
     static final public String LEVEL_ATTRIBUTE = "level";
+    static final public String LEVEL_ELEMENT = "level";
+    static final public String LEVEL_DEFAULT_ELEMENT = "defaultLevel";
     static final public String LEVEL_DEFAULT_STR = "defaultlevel";
     static final public String LEVELS_STR = "levels";
@@ -151,4 +176,6 @@
     static final public String METADATA_SET_EXTENSION = ".mds";
     static final public String METADATA_STR = "metadata";
+    static final public String METADATALIST_STR = "metadataList";
+    static final public String METADATALIST_ELEMENT = "MetadataList";
     static final public String METADATA_TYPE_STR = "metadata";
     static final public String METADATA_XML = "metadata.xml";
@@ -160,4 +187,5 @@
     static final public String MODEL_COLLECTION_NAME = "modelcol";
     static final public String NAME_ATTRIBUTE = "name";
+    static final public String NAME_STR = "name";
     static final public String NAME_ELEMENT = "Name";
     static final public String NEWLINE_CHARACTER = "\\";
@@ -166,4 +194,6 @@
     static final public String OPEN_PARENTHESIS_CHARACTER = "(";
     static final public String OPTION_ELEMENT = "Option";
+    static final public String OPTION_STR = "option";
+
     static final public String OPTIONS_ATTRIBUTE = "options";
     static final public String PARAGRAPH_STR = "paragraph";
@@ -172,10 +202,14 @@
     static final public String PLUGIN_ELEMENT = "Plugin";
     static final public String PLUGIN_STR = "plugin";
+    static final public String PLUGINLIST_STR = "pluginList";
     static final public String PREDEFINED_METADATA_ATTRIBUTE = "predefined";          
     static final public String RBRACKET_CHARACTER = "]";
     static final public String RECPLUG_STR = "RecPlug";
     static final public String REGEXP_STR = "regexp";
+    static final public String REPLACELISTREF_STR = "replaceListRef";
     static final public String RESTRICTED_METADATA_ATTRIBUTE = "restricted";
+    static final public String SEARCHTYPE_ELEMENT = "searchType";
     static final public String SEARCHTYPE_STR = "searchtype";
+    static final public String SEARCH_STR = "search";
     static final public String SECTION_ELEMENT = "Section";
     static final public String SECTION_STR = "section";
@@ -185,4 +219,5 @@
     static final public String SINGLE_QUOTE_CHARACTER = "'";
     static final public String SITE_ARGUMENT = "-site";
+    static final public String SMALLICON_STR = "smallicon";
     static final public String SPACE_CHARACTER = " ";
     static final public String SPECIAL_ATTRIBUTE = "special";
@@ -196,4 +231,5 @@
     static final public String SUBCOLLECTION_DEFAULT_INDEX_STR = "defaultsubcollection";
     static final public String SUBCOLLECTION_INDEX_STR = "indexsubcollections";
+    static final public String SUBCOLLECTION_INDEX_ELEMENT = "indexSubcollection";
     static final public String SUBCOLLECTION_INDEXES_ELEMENT = "SubcollectionIndexes";
     static final public String SUPERCOLLECTION_ELEMENT = "Supercollection";
@@ -204,4 +240,5 @@
     static final public String TIMESTAMP_ARGUMENT = "&uq=";
     static final public String TITLE_ELEMENT = "Title";
+    static final public String SOURCE_ELEMENT = "Source";
     static final public String TRUE_STR = "true";
     static final public String TYPE_ATTRIBUTE = "type";
@@ -221,3 +258,9 @@
     static final public String CACHE_FOLDER                               = "cache";
     static final public String CUSTOM_ATTRIBUTE                           = "custom";
+    static final public String MG_STR                           = "mg";
+    static final public String MGPP_STR                           = "mgpp";
+    static final public String LUCENE_STR                           = "lucene";
+    
+    static final public String CLASSIFIER_DEFAULT_FORMAT = "<gsf:template match='documentNode'><td valign='top'><gsf:link type='document'><gsf:icon type='document'/></gsf:link></td> <td valign='top'><gsf:metadata name='srclink' /><gsf:choose-metadata><gsf:metadata name='thumbicon' /><gsf:metadata name='srcicon' /></gsf:choose-metadata><gsf:metadata name='/srclink' /></td> <td valign='top'> <gsf:choose-metadata><gsf:metadata name='dc.Title' /><gsf:metadata name='exp.Title' /><gsf:metadata name='Title' /><gsf:default>Untitled</gsf:default></gsf:choose-metadata> <gsf:switch><gsf:metadata name='Source' /><gsf:when test='exists' ><br /><i>(<gsf:metadata name='Source' />)</i></gsf:when></gsf:switch></td></gsf:template><gsf:template match='classifierNode'><td valign='top'><gsf:link type='classifier'><gsf:icon type='classifier'/></gsf:link></td> <td valign='top'><gsf:metadata name='srclink' /><gsf:choose-metadata><gsf:metadata name='thumbicon' /><gsf:metadata name='srcicon' /></gsf:choose-metadata><gsf:metadata name='/srclink' /></td> <td valign='top'> <gsf:choose-metadata><gsf:metadata name='dc.Title' /><gsf:metadata name='exp.Title' /><gsf:metadata name='Title' /><gsf:default>Untitled</gsf:default></gsf:choose-metadata> <gsf:switch><gsf:metadata name='Source' /><gsf:when test='exists' ><br /><i>(<gsf:metadata name='Source' />)</i></gsf:when></gsf:switch></td></gsf:template><gsf:template match='classifierNode' mode='horizontal'><gsf:link type='horizontal'><gsf:metadata name='Title' /></gsf:link></gsf:template>";
+
 }