Index: /trunk/gsdl3/web/sites/localsite/collect/gs2mgdemo/etc/collectionConfig.xml
===================================================================
--- /trunk/gsdl3/web/sites/localsite/collect/gs2mgdemo/etc/collectionConfig.xml	(revision 14054)
+++ /trunk/gsdl3/web/sites/localsite/collect/gs2mgdemo/etc/collectionConfig.xml	(revision 14055)
@@ -1,80 +1,65 @@
-<collectionConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-><metadataList
-><metadata name="creator"
->greenstone@cs.waikato.ac.nz</metadata
-><metadata name="public"
->true</metadata
-></metadataList
-><displayItemList
-><displayItem name="description" lang="en"
->This is a demonstration collection for the Greenstone3 digital library software. It contains a small subset (11 books) of the Humanitarian and Development Libraries. It is a Greenstone2 collection, built with MG. The Greenstone2 configuration files have been converted to Greenstone3 equivalents, enabling it to be served using Greenstone3.</displayItem
-><displayItem name="name" lang="en"
->Greenstone2 MG demo collection</displayItem
-><displayItem name="icon" lang="en"
->gs2mgdemo.gif</displayItem
-><displayItem name="smallicon" lang="en"
->gs2mgdemo_sm.gif</displayItem
-></displayItemList
-><search
-><index name="document:text"
-><displayItem name="name" lang="ru"
->ÐÐŸÐ»ÐœÑÐµ ÐŽÐŸÐºÑÐŒÐµÐœÑÑ</displayItem
-><displayItem name="name" lang="en"
->entire documents</displayItem
-><displayItem name="name" lang="fr"
->documents entiers</displayItem
-><displayItem name="name" lang="es"
->documentos enteros</displayItem
-></index
-><index name="section:Title"
-><displayItem name="name" lang="ru"
->ÐÐ°Ð·Ð²Ð°ÐœÐžÑ ÑÐ°Ð·ÐŽÐµÐ»ÐŸÐ²</displayItem
-><displayItem name="name" lang="en"
->section titles</displayItem
-><displayItem name="name" lang="fr"
->titres des sections</displayItem
-><displayItem name="name" lang="es"
->tÃ­tulos de las secciones</displayItem
-></index
-><index name="section:text"
-><displayItem name="name" lang="ru"
->ÐÐ»Ð°Ð²Ñ</displayItem
-><displayItem name="name" lang="en"
->chapters</displayItem
-><displayItem name="name" lang="fr"
->chapitres</displayItem
-><displayItem name="name" lang="es"
->capÃ­tulos</displayItem
-></index
-><format
-><gsf:template match="documentNode"
-><td valign='top'><gsf:link type='document'><gsf:icon type='document'/></gsf:link></td><td><gsf:switch><gsf:metadata name='Title' select='ancestors' separator=': ' /><gsf:when test='exists' ><gsf:metadata name='Title' select='ancestors' separator=': ' />:</gsf:when></gsf:switch><gsf:link type='document'><gsf:metadata name='Title' /></gsf:link></td></gsf:template
-></format
-></search
-><browse
-><format
-><gsf:template match="documentNode"
-><td valign="top"><gsf:link type='document'><gsf:icon type='document'/></gsf:link></td> <td valign="top"><gsf:metadata name='srclink' /><gsf:choose-metadata><gsf:metadata name='thumbicon' /><gsf:metadata name='srcicon' /></gsf:choose-metadata><gsf:metadata name='/srclink' /></td> <td valign="top"> <gsf:choose-metadata><gsf:metadata name='dc.Title' /><gsf:metadata name='exp.Title' /><gsf:metadata name='Title' /><gsf:default>Untitled</gsf:default></gsf:choose-metadata> <gsf:switch><gsf:metadata name='Source' /><gsf:when test='exists' ><br /><i>(<gsf:metadata name='Source' />)</i></gsf:when></gsf:switch></td></gsf:template
-><gsf:template match="classifierNode"
-><td valign="top"><gsf:link type='classifier'><gsf:icon type='classifier'/></gsf:link></td> <td valign="top"><gsf:metadata name='srclink' /><gsf:choose-metadata><gsf:metadata name='thumbicon' /><gsf:metadata name='srcicon' /></gsf:choose-metadata><gsf:metadata name='/srclink' /></td> <td valign="top"> <gsf:choose-metadata><gsf:metadata name='dc.Title' /><gsf:metadata name='exp.Title' /><gsf:metadata name='Title' /><gsf:default>Untitled</gsf:default></gsf:choose-metadata> <gsf:switch><gsf:metadata name='Source' /><gsf:when test='exists' ><br /><i>(<gsf:metadata name='Source' />)</i></gsf:when></gsf:switch></td></gsf:template
-><gsf:template match="classifierNode" mode="horizontal"
-><gsf:link type='horizontal'><gsf:metadata name='Title' /></gsf:link></gsf:template
-></format
-><classifier name="CL1"
-></classifier
-><classifier name="CL2"
-></classifier
-><classifier name="CL3"
-></classifier
-><classifier name="CL4"
-><format
-><gsf:template match="documentNode"
-><br /><gsf:link type='document'><gsf:metadata name='dls.Keyword' /></gsf:link></gsf:template
-><gsf:template match="classifierNode"
-><br /><gsf:link type='classifier'><gsf:metadata name='dls.Keyword' /></gsf:link></gsf:template
-></format
-></classifier
-></browse
-><replaceListRef id="gs2-standard"
- /></collectionConfig
->
+<?xml version="1.0" encoding="UTF-8"?>
+<CollectionConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+    <metadataList>
+        <metadata lang="en" name="creator">greenstone@cs.waikato.ac.nz</metadata>
+        <metadata lang="en" name="maintainer"/>
+        <metadata lang="en" name="public">true</metadata>
+    </metadataList>
+    <displayItemList>
+        <displayItem assigned="true" lang="en" name="description">This is a demonstration collection for the Greenstone3 digital library software. It contains a small subset (11 books) of the Humanitarian and Development Libraries. It is a Greenstone2 collection, built with MG. The Greenstone2 configuration files have been converted to Greenstone3 equivalents, enabling it to be served using Greenstone3.</displayItem>
+        <displayItem assigned="true" lang="en" name="smallicon">gs2mgdemo_sm.gif</displayItem>
+        <displayItem assigned="true" lang="en" name="icon">gs2mgdemo.gif</displayItem>
+        <displayItem assigned="true" lang="en" name="name">Greenstone2 MG demo collection</displayItem>
+    </displayItemList>
+    <search type="mg">
+        <index name="document:text">
+            <displayItem lang="ru" name="name">ÐÐŸÐ»ÐœÑÐµ ÐŽÐŸÐºÑÐŒÐµÐœÑÑ</displayItem>
+            <displayItem lang="en" name="name">entire documents</displayItem>
+            <displayItem lang="es" name="name">documentos enteros</displayItem>
+            <displayItem lang="fr" name="name">documents entiers</displayItem>
+        </index>
+        <index name="section:Title">
+            <displayItem lang="ru" name="name">ÐÐ°Ð·Ð²Ð°ÐœÐžÑ ÑÐ°Ð·ÐŽÐµÐ»ÐŸÐ²</displayItem>
+            <displayItem lang="en" name="name">section titles</displayItem>
+            <displayItem lang="es" name="name">tÃ­tulos de las secciones</displayItem>
+            <displayItem lang="fr" name="name">titres des sections</displayItem>
+        </index>
+        <index name="section:text">
+            <displayItem lang="ru" name="name">ÐÐ»Ð°Ð²Ñ</displayItem>
+            <displayItem lang="en" name="name">chapters</displayItem>
+            <displayItem lang="es" name="name">capÃ­tulos</displayItem>
+            <displayItem lang="fr" name="name">chapitres</displayItem>
+        </index>
+        <format name="searchType">plain,form</format>
+        <format><gsf:template match="documentNode">                                                                                                                      <td valign="top">                                                                                                                                                                                 <gsf:link type="document">                                                                                                                                                                                                                                            <gsf:icon type="document"/>                                                                                                                                                                                                              </gsf:link>                                                                                                                                                   </td>                                                                                                                      <td>                                                                                                                                                                                 <gsf:switch>                                                                                                                                                                                                                                            <gsf:metadata name="Title" select="ancestors" separator=": "/>                                                                                                                                                                                                                                            <gsf:when test="exists">                                                                                                                                                                                                                                                                                                       <gsf:metadata name="Title" select="ancestors" separator=": "/>                                                                                                                                                      :                                                                                                                        </gsf:when>                                                                                                                                                                                                              </gsf:switch>                                                                                                                                                                                 <gsf:link type="document">                                                                                                                                                                                                                                            <gsf:metadata name="Title"/>                                                                                                                                                                                                              </gsf:link>                                                                                                                                                   </td>                                                                                        </gsf:template></format>
+    </search>
+    <import>
+        <pluginList>
+            <plugin name="ZIPPlug"/>
+            <plugin name="GAPlug"/>
+            <plugin name="TEXTPlug"/>
+            <plugin name="HTMLPlug"/>
+            <plugin name="EMAILPlug"/>
+            <plugin name="PDFPlug"/>
+            <plugin name="RTFPlug"/>
+            <plugin name="WordPlug"/>
+            <plugin name="MetadataXMLPlug"/>
+            <plugin name="ArcPlug"/>
+            <plugin name="RecPlug"/>
+        </pluginList>
+    </import>
+    <browse>
+        <classifier name="AZList">
+            <option name="-metadata" value="dls.Subject"/>
+            <format><gsf:template match="classifierNode" mode="horizontal">                                                              <gsf:link type="horizontal">                                                                                             <gsf:metadata name="Title"/>                                                                             </gsf:link>                                              </gsf:template></format>
+        </classifier>
+        <classifier name="AZCompactList">
+            <option name="-metadata" value="dls.Title"/>
+        </classifier>
+        <format><gsf:template match="documentNode">                                                                                                                      <td valign="top">                                                                                                                                                                                 <gsf:link type="document">                                                                                                                                                                                                                                            <gsf:icon type="document"/>                                                                                                                                                                                                              </gsf:link>                                                                                                                                                   </td>                                                                                                                         <td valign="top">                                                                                                                                                                                 <gsf:metadata name="srclink"/>                                                                                                                                                                                 <gsf:choose-metadata>                                                                                                                                                                                                                                            <gsf:metadata name="thumbicon"/>                                                                                                                                                                                                                                            <gsf:metadata name="srcicon"/>                                                                                                                                                                                                              </gsf:choose-metadata>                                                                                                                                                                                 <gsf:metadata name="/srclink"/>                                                                                                                                                   </td>                                                                                                                         <td valign="top">                                                                                                                                                                                     <gsf:choose-metadata>                                                                                                                                                                                                                                            <gsf:metadata name="dc.Title"/>                                                                                                                                                                                                                                            <gsf:metadata name="exp.Title"/>                                                                                                                                                                                                                                            <gsf:metadata name="Title"/>                                                                                                                                                                                                                                            <gsf:default>                                                                                                                                                      Untitled                                                                                                                        </gsf:default>                                                                                                                                                                                                              </gsf:choose-metadata>                                                                                                                                                                                     <gsf:switch>                                                                                                                                                                                                                                            <gsf:metadata name="Source"/>                                                                                                                                                                                                                                            <gsf:when test="exists">                                                                                                                                                                                                                                                                                                       <br/>                                                                                                                                                                                                                                                                                                       <i>                                                                                                                                                                                    (                                                                                                                                                                                    <gsf:metadata name="Source"/>                                                                                                                                                                                    )                                                                                                                                                      </i>                                                                                                                                                                                                                                                                         </gsf:when>                                                                                                                                                                                                              </gsf:switch>                                                                                                                                                   </td>                                                                                        </gsf:template>                                                           <gsf:template match="classifierNode">                                                                                                                      <td valign="top">                                                                                                                                                                                 <gsf:link type="classifier">                                                                                                                                                                                                                                            <gsf:icon type="classifier"/>                                                                                                                                                                                                              </gsf:link>                                                                                                                                                   </td>                                                                                                                         <td valign="top">                                                                                                                                                                                 <gsf:metadata name="srclink"/>                                                                                                                                                                                 <gsf:choose-metadata>                                                                                                                                                                                                                                            <gsf:metadata name="thumbicon"/>                                                                                                                                                                                                                                            <gsf:metadata name="srcicon"/>                                                                                                                                                                                                              </gsf:choose-metadata>                                                                                                                                                                                 <gsf:metadata name="/srclink"/>                                                                                                                                                   </td>                                                                                                                         <td valign="top">                                                                                                                                                                                     <gsf:choose-metadata>                                                                                                                                                                                                                                            <gsf:metadata name="dc.Title"/>                                                                                                                                                                                                                                            <gsf:metadata name="exp.Title"/>                                                                                                                                                                                                                                            <gsf:metadata name="Title"/>                                                                                                                                                                                                                                            <gsf:default>                                                                                                                                                      Untitled                                                                                                                        </gsf:default>                                                                                                                                                                                                              </gsf:choose-metadata>                                                                                                                                                                                     <gsf:switch>                                                                                                                                                                                                                                            <gsf:metadata name="Source"/>                                                                                                                                                                                                                                            <gsf:when test="exists">                                                                                                                                                                                                                                                                                                       <br/>                                                                                                                                                                                                                                                                                                       <i>                                                                                                                                                                                    (                                                                                                                                                                                    <gsf:metadata name="Source"/>                                                                                                                                                                                    )                                                                                                                                                      </i>                                                                                                                                                                                                                                                                         </gsf:when>                                                                                                                                                                                                              </gsf:switch>                                                                                                                                                   </td>                                                                                        </gsf:template>                                                           <gsf:template match="classifierNode" mode="horizontal">                                                                                                                      <gsf:link type="horizontal">                                                                                                                                                                                 <gsf:metadata name="Title"/>                                                                                                                                                   </gsf:link>                                                                                        </gsf:template></format>
+    </browse>
+    <display>
+        <format><gsf:template match="documentcontent">                                                                                               </gsf:template>                                                                <gsf:option name="TOC" value="true"/>                                       </format>
+    </display>
+    <replaceListRef id="gs2-standard"/>
+</CollectionConfig>
Index: /trunk/gsdl3/web/sites/localsite/collect/gs2mgdemo/gs2mgdemo.col
===================================================================
--- /trunk/gsdl3/web/sites/localsite/collect/gs2mgdemo/gs2mgdemo.col	(revision 14054)
+++ /trunk/gsdl3/web/sites/localsite/collect/gs2mgdemo/gs2mgdemo.col	(revision 14055)
@@ -16,6 +16,25 @@
     <GathererConfig/>
     <BuildConfig>
-        <Build/>
-        <Import/>
+        <Build>
+            <Argument enabled="false" name="faillog"/>
+            <Argument enabled="false" name="index"/>
+            <Argument enabled="false" name="language"/>
+            <Argument enabled="false" name="maxnumeric">4</Argument>
+            <Argument enabled="false" name="mode">all</Argument>
+            <Argument enabled="false" name="sections_index_document_metadata">never</Argument>
+            <Argument enabled="false" name="verbosity">0</Argument>
+        </Build>
+        <Import>
+            <Argument enabled="false" name="faillog"/>
+            <Argument enabled="false" name="maxdocs">1</Argument>
+            <Argument enabled="false" name="OIDtype">hash</Argument>
+            <Argument enabled="false" name="OIDmetadata">dls.Title</Argument>
+            <Argument enabled="false" name="saveas">GA</Argument>
+            <Argument enabled="false" name="sortmeta">dls.Title</Argument>
+            <Argument enabled="false" name="removeprefix"/>
+            <Argument enabled="false" name="removesuffix"/>
+            <Argument enabled="false" name="groupsize">1</Argument>
+            <Argument enabled="false" name="verbosity">0</Argument>
+        </Import>
     </BuildConfig>
 </GathererCollection>