Index: /trunk/gsdl3/web/sites/localsite/collect/gs2mgdemo/index/buildConfig.xml
===================================================================
--- /trunk/gsdl3/web/sites/localsite/collect/gs2mgdemo/index/buildConfig.xml	(revision 14058)
+++ /trunk/gsdl3/web/sites/localsite/collect/gs2mgdemo/index/buildConfig.xml	(revision 14059)
@@ -1,37 +1,33 @@
-<buildConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
-><metadataList
-><metadata name="numDocs"
->11</metadata
-><metadata name="buildType"
->mg</metadata
-></metadataList
-><serviceRackList
-><serviceRack name="GS2MGRetrieve"
-><defaultIndex shortname="ste"
- /><indexStem name="gs2mgdemo"
- /></serviceRack
-><serviceRack name="GS2Browse"
-><indexStem name="gs2mgdemo"
- /><classifierList
-><classifier name="CL1" content="Subject"
- /><classifier name="CL2" content="dls.Title"
- /><classifier name="CL3" content="Organization"
- /><classifier name="CL4" content="Howto"
- /></classifierList
-></serviceRack
-><serviceRack name="GS2MGSearch"
-><defaultIndex shortname="ste"
- /><indexList
-><index name="section:text" shortname="ste"
- /><index name="section:Title" shortname="sti"
- /><index name="document:text" shortname="dte"
- /></indexList
-><indexStem name="gs2mgdemo"
- /><indexOptionList
-><indexOption name="stemIndexes" value="3"
- /><indexOption name="maxnumeric" value="4"
- /></indexOptionList
-></serviceRack
-></serviceRackList
-></buildConfig
->
+<buildConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat">
+<metadataList>
+<metadata name="numDocs">11</metadata>
+<metadata name="buildType">mg</metadata>
+</metadataList>
+<serviceRackList>
+<serviceRack name="GS2MGSearch">
+<indexStem name="gs2mgdemo" />
+<indexList>
+<index name="document:text" shortname="dte" />
+<index name="section:Title" shortname="sti" />
+<index name="section:text" shortname="ste" />
+</indexList>
+<defaultIndex shortname="dte" />
+<indexOptionList>
+<indexOption name="stemIndexes" value="3" />
+<indexOption name="maxnumeric" value="4" />
+</indexOptionList>
+<defaultGDBMLevel shortname="Doc" />
+</serviceRack>
+<serviceRack name="GS2MGRetrieve">
+<defaultIndex shortname="dte" />
+<indexStem name="gs2mgdemo" />
+</serviceRack>
+<serviceRack name="GS2Browse">
+<indexStem name="gs2mgdemo" />
+<classifierList>
+<classifier name="CL1" content="dls.Subject" />
+<classifier name="CL2" content="dls.Title" />
+</classifierList>
+</serviceRack>
+</serviceRackList>
+</buildConfig>
Index: /trunk/gsdl3/web/sites/localsite/collect/gs2mgppdemo/index/buildConfig.xml
===================================================================
--- /trunk/gsdl3/web/sites/localsite/collect/gs2mgppdemo/index/buildConfig.xml	(revision 14058)
+++ /trunk/gsdl3/web/sites/localsite/collect/gs2mgppdemo/index/buildConfig.xml	(revision 14059)
@@ -1,49 +1,44 @@
-<buildConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
-><metadataList
-><metadata name="numDocs"
->11</metadata
-><metadata name="buildType"
->mgpp</metadata
-></metadataList
-><serviceRackList
-><serviceRack name="GS2MGPPRetrieve"
-><defaultLevel shortname="Sec"
- /><indexStem name="gs2mgppdemo"
- /></serviceRack
-><serviceRack name="GS2Browse"
-><indexStem name="gs2mgppdemo"
- /><classifierList
-><classifier name="CL1" content="dls.Title"
- /><classifier name="CL2" content="dls.Subject"
- /><classifier name="CL3" content="Organization"
- /><classifier name="CL4" content="Howto"
- /></classifierList
-></serviceRack
-><serviceRack name="GS2MGPPSearch"
-><defaultIndex shortname="ZZ"
- /><indexList
-><index name="allfields" shortname="ZZ"
- /><index name="text" shortname="TX"
- /><index name="dls.Title" shortname="DL"
- /><index name="dls.Subject" shortname="DS"
- /><index name="dls.Organization" shortname="DO"
- /></indexList
-><indexStem name="gs2mgppdemo"
- /><indexOptionList
-><indexOption name="stemIndexes" value="7"
- /><indexOption name="maxnumeric" value="4"
- /></indexOptionList
-><defaultLevel shortname="Sec"
- /><defaultGDBMLevel shortname="Sec"
- /><levelList
-><level name="section" shortname="Sec"
- /><level name="document" shortname="Doc"
- /></levelList
-><searchTypeList
-><searchType name="form"
- /><searchType name="plain"
- /></searchTypeList
-></serviceRack
-></serviceRackList
-></buildConfig
->
+<buildConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat">
+<metadataList>
+<metadata name="numDocs">11</metadata>
+<metadata name="buildType">mgpp</metadata>
+</metadataList>
+<serviceRackList>
+<serviceRack name="GS2MGPPSearch">
+<indexStem name="gs2mgppdemo" />
+<indexList>
+<index name="dls.Organization" shortname="DL" />
+<index name="dls.Title" shortname="DS" />
+<index name="text" shortname="TX" />
+<index name="allfields" shortname="ZZ" />
+<index name="dls.Subject" shortname="DU" />
+</indexList>
+<indexOptionList>
+<indexOption name="stemIndexes" value="7" />
+<indexOption name="maxnumeric" value="4" />
+</indexOptionList>
+<levelList>
+<level name="document" shortname="Doc" />
+</levelList>
+<defaultLevel shortname="Doc" />
+<defaultGDBMLevel shortname="Doc" />
+<searchTypeList>
+<searchType name="plain" />
+<searchType name="form" />
+</searchTypeList>
+</serviceRack>
+<serviceRack name="GS2MGPPRetrieve">
+<indexStem name="gs2mgppdemo" />
+<defaultLevel shortname="Doc" />
+</serviceRack>
+<serviceRack name="GS2Browse">
+<indexStem name="gs2mgppdemo" />
+<classifierList>
+<classifier name="CL1" content="dls.Title" />
+<classifier name="CL2" content="dls.Subject" />
+<classifier name="CL3" content="Organization" />
+<classifier name="CL4" content="Howto" />
+</classifierList>
+</serviceRack>
+</serviceRackList>
+</buildConfig>